Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zprod.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zprod.F90	(revision 2715)
@@ -22,7 +22,4 @@
    USE iom
 
-   USE lib_mpp
-   USE lib_fortran
-
    IMPLICIT NONE
    PRIVATE
@@ -30,6 +27,6 @@
    PUBLIC   p4z_prod         ! called in p4zbio.F90
    PUBLIC   p4z_prod_init    ! called in trcsms_pisces.F90
-
-   !! * Shared module variables
+   PUBLIC   p4z_prod_alloc
+
    REAL(wp), PUBLIC ::   &
      pislope   = 3.0_wp          ,  &  !:
@@ -43,5 +40,5 @@
      grosip    = 0.151_wp
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk)  ::  prmax 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   prmax   !:
    
    REAL(wp) ::   &
@@ -56,7 +53,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -70,5 +66,15 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   zmixnano   => wrk_2d_1  , zmixdiat    => wrk_2d_2  , zstrn  => wrk_2d_3
+      USE wrk_nemo, ONLY:   zpislopead => wrk_3d_2  , zpislopead2 => wrk_3d_3
+      USE wrk_nemo, ONLY:   zprdia     => wrk_3d_4  , zprbio      => wrk_3d_5  , zysopt => wrk_3d_6
+      USE wrk_nemo, ONLY:   zprorca    => wrk_3d_7  , zprorcad    => wrk_3d_8
+      USE wrk_nemo, ONLY:   zprofed    => wrk_3d_9  , zprofen     => wrk_3d_10
+      USE wrk_nemo, ONLY:   zprochln   => wrk_3d_11 , zprochld    => wrk_3d_12
+      USE wrk_nemo, ONLY:   zpronew    => wrk_3d_13 , zpronewd    => wrk_3d_14
+      !
       INTEGER, INTENT(in) :: kt, jnt
+      !
       INTEGER  ::   ji, jj, jk
       REAL(wp) ::   zsilfac, zfact
@@ -81,27 +87,25 @@
       REAL(wp) ::   zrfact2
 #endif
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zmixnano   , zmixdiat, zstrn
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zpislopead , zpislopead2
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zprdia     , zprbio, zysopt
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zprorca    , zprorcad, zprofed
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zprofen   , zprochln, zprochld
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zpronew    , zpronewd
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
 
-      zprorca (:,:,:) = 0.0
-      zprorcad(:,:,:) = 0.0
-      zprofed(:,:,:) = 0.0
-      zprofen(:,:,:) = 0.0
-      zprochln(:,:,:) = 0.0
-      zprochld(:,:,:) = 0.0
-      zpronew (:,:,:) = 0.0
-      zpronewd(:,:,:) = 0.0
-      zprdia  (:,:,:) = 0.0
-      zprbio  (:,:,:) = 0.0
-      zysopt  (:,:,:) = 0.0
+      IF( wrk_in_use(2, 1,2,3)                             .OR.  &
+          wrk_in_use(3, 2,3,4,5,6,7,8,9,10,11,12,13,14)  ) THEN
+          CALL ctl_stop('p4z_prod: requested workspace arrays unavailable')   ;   RETURN
+      ENDIF
+
+      zprorca (:,:,:) = 0._wp
+      zprorcad(:,:,:) = 0._wp
+      zprofed (:,:,:) = 0._wp
+      zprofen (:,:,:) = 0._wp
+      zprochln(:,:,:) = 0._wp
+      zprochld(:,:,:) = 0._wp
+      zpronew (:,:,:) = 0._wp
+      zpronewd(:,:,:) = 0._wp
+      zprdia  (:,:,:) = 0._wp
+      zprbio  (:,:,:) = 0._wp
+      zysopt  (:,:,:) = 0._wp
 
       ! Computation of the optimal production
-
 # if defined key_degrad
       prmax(:,:,:) = rday1 * tgfunc(:,:,:) * facvol(:,:,:)
@@ -111,9 +115,9 @@
 
       ! compute the day length depending on latitude and the day
-      zrum = FLOAT( nday_year - 80 ) / REAL(nyear_len(1), wp)
-      zcodel = ASIN(  SIN( zrum * rpi * 2. ) * SIN( rad * 23.5 )  )
+      zrum = REAL( nday_year - 80, wp ) / REAL( nyear_len(1), wp )
+      zcodel = ASIN(  SIN( zrum * rpi * 2._wp ) * SIN( rad * 23.5_wp )  )
 
       ! day length in hours
-      zstrn(:,:) = 0.
+      zstrn(:,:) = 0._wp
       DO jj = 1, jpj
          DO ji = 1, jpi
@@ -187,5 +191,4 @@
                   zsilfac = MIN( 6.4,zsilfac * zsilfac2)
                   zysopt(ji,jj,jk) = grosip * zlim1 * zsilfac
-
               ENDIF
             END DO
@@ -357,14 +360,18 @@
 #endif
 
-       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
          WRITE(charout, FMT="('prod')")
          CALL prt_ctl_trc_info(charout)
          CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
-       ENDIF
-
+      ENDIF
+
+      IF(  wrk_not_released(2, 1,2,3)                          .OR.  &
+           wrk_not_released(3, 2,3,4,5,6,7,8,9,10,11,12,13,14)   )   &
+           CALL ctl_stop('p4z_prod: failed to release workspace arrays')
+      !
    END SUBROUTINE p4z_prod
 
+
    SUBROUTINE p4z_prod_init
-
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE p4z_prod_init  ***
@@ -376,9 +383,8 @@
       !!
       !! ** input   :   Namelist nampisprod
-      !!
       !!----------------------------------------------------------------------
-
       NAMELIST/nampisprod/ pislope, pislope2, excret, excret2, chlcnm, chlcdm,   &
          &              fecnm, fecdm, grosip
+      !!----------------------------------------------------------------------
 
       REWIND( numnat )                     ! read numnat
@@ -399,13 +405,22 @@
          WRITE(numout,*) '    Minimum Fe/C in diatoms                   fecdm     =', fecdm
       ENDIF
-
+      !
       rday1     = 0.6 / rday 
       texcret   = 1.0 - excret
       texcret2  = 1.0 - excret2
       tpp       = 0.
-
+      !
    END SUBROUTINE p4z_prod_init
 
 
+   INTEGER FUNCTION p4z_prod_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_prod_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( prmax(jpi,jpj,jpk), STAT=p4z_prod_alloc )
+      !
+      IF( p4z_prod_alloc /= 0 ) CALL ctl_warn('p4z_prod_alloc : failed to allocate arrays.')
+      !
+   END FUNCTION p4z_prod_alloc
 
 #else
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zrem.F90	(revision 2715)
@@ -29,6 +29,6 @@
    PUBLIC   p4z_rem         ! called in p4zbio.F90
    PUBLIC   p4z_rem_init    ! called in trcsms_pisces.F90
-
-   !! * Shared module variables
+   PUBLIC   p4z_rem_alloc
+
    REAL(wp), PUBLIC ::   &
      xremik  = 0.3_wp      ,  & !:
@@ -39,6 +39,5 @@
      oxymin  = 1.e-6_wp         !:
 
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::    & !:
-     &                   denitr                     !: denitrification array
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   denitr   !: denitrification array
 
 
@@ -48,7 +47,6 @@
    !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -61,5 +59,10 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY:   ztempbac => wrk_2d_1
+      USE wrk_nemo, ONLY:   zdepbac  => wrk_3d_2 , zfesatur => wrk_3d_2 , zolimi => wrk_3d_4
+      !
       INTEGER, INTENT(in) ::   kt ! ocean time step
+      !
       INTEGER  ::   ji, jj, jk
       REAL(wp) ::   zremip, zremik , zlam1b
@@ -72,21 +75,20 @@
 #endif
       REAL(wp) ::   zlamfac, zonitr, zstep
-      REAL(wp), DIMENSION(jpi,jpj)     ::   ztempbac
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zdepbac, zfesatur, zolimi
       CHARACTER (len=25) :: charout
-
       !!---------------------------------------------------------------------
 
+      IF(  wrk_in_use(2, 1)  .OR.  wrk_in_use(3, 2,3,4)  ) THEN
+         CALL ctl_stop('p4z_rem: requested workspace arrays unavailable')   ;   RETURN
+      ENDIF
 
        ! Initialisation of temprary arrys
-       zdepbac (:,:,:) = 0.0
-       zfesatur(:,:,:) = 0.0
-       zolimi  (:,:,:) = 0.0
-       ztempbac(:,:)   = 0.0
+       zdepbac (:,:,:) = 0._wp
+       zfesatur(:,:,:) = 0._wp
+       zolimi  (:,:,:) = 0._wp
+       ztempbac(:,:)   = 0._wp
 
       !  Computation of the mean phytoplankton concentration as
       !  a crude estimate of the bacterial biomass
       !   --------------------------------------------------
-
       DO jk = 1, jpkm1
          DO jj = 1, jpj
@@ -362,18 +364,17 @@
                tra(ji,jj,jk,jpbfe) = tra(ji,jj,jk,jpbfe) + zscave * zdenom2
 #endif
-
-            END DO
-         END DO
-      END DO
-      !
-
-       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+            END DO
+         END DO
+      END DO
+      !
+
+      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
          WRITE(charout, FMT="('rem5')")
          CALL prt_ctl_trc_info(charout)
          CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
-       ENDIF
-
-       !     Update the arrays TRA which contain the biological sources and sinks
-       !     --------------------------------------------------------------------
+      ENDIF
+
+      !     Update the arrays TRA which contain the biological sources and sinks
+      !     --------------------------------------------------------------------
 
       DO jk = 1, jpkm1
@@ -385,16 +386,19 @@
          tra(:,:,jk,jpdic) = tra(:,:,jk,jpdic) + zolimi(:,:,jk) + denitr(:,:,jk)
          tra(:,:,jk,jptal) = tra(:,:,jk,jptal) + denitr(:,:,jk) * rno3 * rdenit
-     END DO
-
-       IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
+      END DO
+
+      IF(ln_ctl)   THEN  ! print mean trends (used for debugging)
          WRITE(charout, FMT="('rem6')")
          CALL prt_ctl_trc_info(charout)
          CALL prt_ctl_trc(tab4d=tra, mask=tmask, clinfo=ctrcnm)
-       ENDIF
-
+      ENDIF
+      !
+      IF(  wrk_not_released(2, 1)     .OR.   &
+           wrk_not_released(3, 2,3,4)  )   CALL ctl_stop('p4z_rem: failed to release workspace arrays')
+      !
    END SUBROUTINE p4z_rem
 
+
    SUBROUTINE p4z_rem_init
-
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE p4z_rem_init  ***
@@ -408,6 +412,6 @@
       !!
       !!----------------------------------------------------------------------
-
       NAMELIST/nampisrem/ xremik, xremip, nitrif, xsirem, xlam1, oxymin
+      !!----------------------------------------------------------------------
 
       REWIND( numnat )                     ! read numnat
@@ -425,9 +429,20 @@
          WRITE(numout,*) '    halk saturation constant for anoxia       oxymin    =', oxymin
       ENDIF
-
-      nitrfac(:,:,:) = 0.0
-      denitr (:,:,:) = 0.0  
-
+      !
+      nitrfac(:,:,:) = 0._wp
+      denitr (:,:,:) = 0._wp
+      !
    END SUBROUTINE p4z_rem_init
+
+
+   INTEGER FUNCTION p4z_rem_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_rem_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( denitr(jpi,jpj,jpk), STAT=p4z_rem_alloc )
+      !
+      IF( p4z_rem_alloc /= 0 )   CALL ctl_warn('p4z_rem_alloc: failed to allocate arrays')
+      !
+   END FUNCTION p4z_rem_alloc
 
 #else
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2568)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsed.F90	(revision 2715)
@@ -18,6 +18,4 @@
    USE oce_trc         !
    USE sms_pisces
-   USE lib_mpp
-   USE lib_fortran
    USE prtctl_trc
    USE p4zbio
@@ -27,5 +25,4 @@
    USE p4zrem
    USE p4zlim
-   USE lbclnk
    USE iom
 
@@ -36,32 +33,34 @@
    PUBLIC   p4z_sed   
    PUBLIC   p4z_sed_init   
+   PUBLIC   p4z_sed_alloc
 
    !! * Shared module variables
-   LOGICAL, PUBLIC ::    &
-     ln_dustfer  = .FALSE.      ,  &  !:
-     ln_river    = .FALSE.      ,  &  !:
-     ln_ndepo    = .FALSE.      ,  &  !:
-     ln_sedinput = .FALSE.            !:
-
-   REAL(wp), PUBLIC ::   &
-     sedfeinput = 1.E-9_wp   ,  &  !:
-     dustsolub  = 0.014_wp         !:
+   LOGICAL, PUBLIC :: ln_dustfer  = .FALSE.    !: boolean for dust input from the atmosphere
+   LOGICAL, PUBLIC :: ln_river    = .FALSE.    !: boolean for river input of nutrients
+   LOGICAL, PUBLIC :: ln_ndepo    = .FALSE.    !: boolean for atmospheric deposition of N
+   LOGICAL, PUBLIC :: ln_sedinput = .FALSE.    !: boolean for Fe input from sediments
+
+   REAL(wp), PUBLIC :: sedfeinput = 1.E-9_wp   !: Coastal release of Iron
+   REAL(wp), PUBLIC :: dustsolub  = 0.014_wp   !: Solubility of the dust
 
    !! * Module variables
-   REAL(wp) :: ryyss               !: number of seconds per year 
-   REAL(wp) :: ryyss1              !: inverse of ryyss
-   REAL(wp) :: rmtss               !: number of seconds per month
-   REAL(wp) :: rday1               !: inverse of rday
-
-   INTEGER , PARAMETER :: &
-        jpmth = 12, jpyr = 1
-   INTEGER ::                   &
-      numdust,                  &  !: logical unit for surface fluxes data
-      nflx1 , nflx2,            &  !: first and second record used
-      nflx11, nflx12      ! ???
-   REAL(wp), DIMENSION(jpi,jpj,jpmth) ::  dustmo    !: set of dust fields
-   REAL(wp), DIMENSION(jpi,jpj)      ::  rivinp, cotdep, nitdep, dust 
-   REAL(wp), DIMENSION(jpi,jpj)      ::  e1e2t
-   REAL(wp), DIMENSION(jpi,jpj,jpk)  ::  ironsed 
+   REAL(wp) :: ryyss                  !: number of seconds per year 
+   REAL(wp) :: ryyss1                 !: inverse of ryyss
+   REAL(wp) :: rmtss                  !: number of seconds per month
+   REAL(wp) :: rday1                  !: inverse of rday
+
+   INTEGER , PARAMETER :: jpmth = 12  !: number of months per year
+   INTEGER , PARAMETER :: jpyr  = 1   !: one year
+
+   INTEGER ::  numdust                !: logical unit for surface fluxes data
+   INTEGER ::  nflx1 , nflx2          !: first and second record used
+   INTEGER ::  nflx11, nflx12
+
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: dustmo    !: set of dust fields
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:) :: dust      !: dust fields
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:) :: rivinp, cotdep    !: river input fields
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:) :: nitdep    !: atmospheric N deposition 
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: ironsed   !: Coastal supply of iron
+
    REAL(wp) :: sumdepsi, rivalkinput, rivpo4input, nitdepinput
 
@@ -76,4 +75,5 @@
 CONTAINS
 
+
    SUBROUTINE p4z_sed( kt, jnt )
       !!---------------------------------------------------------------------
@@ -86,4 +86,8 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: zsidep => wrk_2d_1, zwork => wrk_2d_2, zwork1 => wrk_2d_3
+      USE wrk_nemo, ONLY: znitrpot => wrk_3d_2, zirondep => wrk_3d_3
+      !
       INTEGER, INTENT(in) ::   kt, jnt ! ocean time step
       INTEGER  ::   ji, jj, jk, ikt
@@ -94,9 +98,10 @@
       REAL(wp) ::   zdenitot, znitrpottot, zlim, zfact
       REAL(wp) ::   zwsbio3, zwsbio4, zwscal
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zsidep
-      REAL(wp), DIMENSION(jpi,jpj)     ::   zwork, zwork1
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   znitrpot, zirondep
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
+
+      IF( ( wrk_in_use(2, 1,2,3) ) .OR. ( wrk_in_use(3, 2,3) ) ) THEN
+         CALL ctl_stop('p4z_sed: requested workspace arrays unavailable')  ;  RETURN
+      END IF
 
       IF( jnt == 1  .AND.  ln_dustfer  )  CALL p4z_sbc( kt )
@@ -288,4 +293,7 @@
        ENDIF
 
+      IF( ( wrk_not_released(2, 1,2,3) ) .OR. ( wrk_not_released(3, 2,3) ) )   &
+        &         CALL ctl_stop('p4z_sed: failed to release workspace arrays')
+
    END SUBROUTINE p4z_sed
 
@@ -474,5 +482,4 @@
       ryyss1 = 1. / ryyss
       !                                    ! ocean surface cell
-      e1e2t(:,:) = e1t(:,:) * e2t(:,:)
 
       ! total atmospheric supply of Si
@@ -512,4 +519,16 @@
    END SUBROUTINE p4z_sed_init
 
+   INTEGER FUNCTION p4z_sed_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_sed_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE( dustmo(jpi,jpj,jpmth), dust(jpi,jpj)       ,     &
+        &       rivinp(jpi,jpj)      , cotdep(jpi,jpj)     ,     &
+        &       nitdep(jpi,jpj)      , ironsed(jpi,jpj,jpk), STAT=p4z_sed_alloc )  
+
+      IF( p4z_sed_alloc /= 0 ) CALL ctl_warn('p4z_sed_alloc : failed to allocate arrays.')
+
+   END FUNCTION p4z_sed_alloc
 #else
    !!======================================================================
